#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
# require 'html_tags/individual_tags/details.rb'
# =========================================================================== #
module HtmlTags

  require 'html_tags/opening_tag/opening_tag.rb'
  require 'html_tags/toplevel_methods/add.rb'

  # ========================================================================= #
  # === HtmlTags.details
  # ========================================================================= #
  def self.details(
      i                   = '',
      css_class           = '',
      the_id              = '',
      css_style           = '',
      optional_javascript = '',
      &block
    )
    # ======================================================================= #
    # === Handle Hashes first
    # ======================================================================= #
    if css_class.is_a? Hash
      # ===================================================================== #
      # === :css_style
      # ===================================================================== #
      if css_class.has_key? :css_style
        css_style = css_class.delete(:css_style)
        if css_class.is_a?(Hash) and css_class.empty?
          css_class = ''
        end
      end
    end
    content = i.to_s.dup
    if block_given?
      content << yield.to_s
    end
    return HtmlTags.add(
      opening_tag(__method__, css_class, the_id, css_style, optional_javascript)+
      content+
      close(__method__)
    )
  end

  # ========================================================================= #
  # === details
  # ========================================================================= #
  def details(
      i                   = '',
      css_class           = '',
      the_id              = '',
      css_style           = '',
      optional_javascript = '',
      &block
    )
    return HtmlTags.details(
      i,
      css_class,
      the_id,
      css_style,
      javascript_code,
      &block
    )
  end

end