#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
module HtmlTags

  # ========================================================================= #
  # === video                                                     (video tag)
  #
  # The goal of this method is to create a String such as
  # '<video src="movie.webm"></video>'.
  # ========================================================================= #
  def video(
      i                   = '', # ← This is the content.
      css_class           = '',
      the_id              = '',
      css_style           = '',
      optional_javascript = '',
      &block
    )
    if i.is_a? Hash
      # ===================================================================== #
      # === :css_class
      # ===================================================================== #
      if i.has_key? :css_class
        css_class = i.delete(:css_class)
      end
      i = ''
    end
    i = i.to_s.dup # And avoid frozen-errors.
    # ======================================================================= #
    # Blocks will be assumed to be used for the first argument, `i`.
    # ======================================================================= #
    if block_given?
      i << yield.to_s
    end
    video_tag = opening_tag(__method__, css_class, the_id, css_style, optional_javascript).dup
    video_tag[-2,0] = ' controls'
    return HtmlTags.add(
      video_tag+
      "<source src=\"#{i}\">"+
      close(__method__)
    )
  end

end

if __FILE__ == $PROGRAM_NAME
  alias e puts
  require 'html_tags/opening_tag/opening_tag.rb'
  require 'html_tags/toplevel_methods/add.rb'
  include HtmlTags
  e video 'foobar.mp4'
end